<?xml version="1.0" encoding="US-ASCII"?>
<?xml-stylesheet type="text/xsl" 
href="file:///z:/data/kendata/dev/xslstyle/xslstyle-docbook.xsl"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xsd="http://www.w3.org/2001/XMLSchema"
                xmlns:xs="http://www.CraneSoftwrights.com/ns/xslstyle"
                version="2.0">

<xs:doc info="$Id: script4load.xsl,v 1.3 2010/02/03 06:16:10 gkholman Exp $"
        filename="script.xsl" vocabulary="DocBook">
  <xs:title>Simple script substitution</xs:title>
  <para>
    This stylesheet simply replaces known placebo elements with expected
    command-line argument strings.
  </para>
</xs:doc>

<xs:output>
  <para>The output needs to look like XQuery</para>
</xs:output>
<xsl:output omit-xml-declaration="yes"/>

<xs:param ns-ignore="yes">
  <para>The base installation directory for the exercises.</para>
</xs:param>
<xsl:param name="dir" required="yes" as="xsd:string"/>

<xs:param ns-ignore="yes">
  <para>The port number on the server for the installation.</para>
</xs:param>
<xsl:param name="exerport" required="yes" as="xsd:string"/>

<xs:param ns-ignore="yes">
  <para>The Mark Logic server username.</para>
</xs:param>
<xsl:param name="username" required="yes" as="xsd:string"/>

<xs:param ns-ignore="yes">
  <para>The Mark Logic server password.</para>
</xs:param>
<xsl:param name="password" required="yes" as="xsd:string"/>

<xs:param ns-ignore="yes">
  <para>The Mark Logic server port for the Docs application server.</para>
</xs:param>
<xsl:param name="docsport" required="yes" as="xsd:string"/>

<xs:template>
  <para>Handle all children when encountered</para>
</xs:template>
<xsl:template match="scripts">
  <xsl:apply-templates select='script'/>
</xsl:template>

<xs:template>
  <para>Pass the body of the script without the wrapper.</para>
</xs:template>
<xsl:template match="script">
  <xsl:message select="'Writing',string(@href)"/>
  <xsl:result-document href="{@href}" method="{@method}">
    <xsl:apply-templates/>
  </xsl:result-document>
</xsl:template>

<xs:template>
  <para>The substitution of the base directory information.</para>
</xs:template>
<xsl:template match="dir">
  <xsl:variable name="composed" 
        select="concat($dir,if( not(ends-with($dir,'/')) ) then '/' else ())"/>
  <xsl:value-of select="translate($composed,'\','/')"/>
</xsl:template>

<xs:template>
  <para>The substitution of the exercise port information.</para>
</xs:template>
<xsl:template match="exerport">
  <xsl:value-of select="$exerport"/>
</xsl:template>

<xs:template>
  <para>The substitution of the server access username.</para>
</xs:template>
<xsl:template match="username">
  <xsl:value-of select="$username"/>
</xsl:template>

<xs:template>
  <para>The substitution of the server access password.</para>
</xs:template>
<xsl:template match="password">
  <xsl:value-of select="$password"/>
</xsl:template>

<xs:template>
  <para>The substitution of the server access port.</para>
</xs:template>
<xsl:template match="docsport">
  <xsl:value-of select="$docsport"/>
</xsl:template>

<xs:template>
  <para>Identity for all other nodes.</para>
</xs:template>
<xsl:template match="@*|node()">
  <xsl:copy>
    <xsl:apply-templates select="@*|node()"/>
  </xsl:copy>
</xsl:template>

</xsl:stylesheet>
