<?xml version="1.0"?><!--bullet.xsl-->
<!--XSLT 1.0 - http://www.CraneSoftwrights.com/training -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

<xsl:output indent="yes"/>

<xsl:template match="doc">
  <html><xsl:apply-templates/></html>
</xsl:template>

<xsl:template match="bullet"> <!--handle every bullet in turn-->
  <xsl:choose><!--don't always act on *every* bullet there is-->
        <!--when there is an immediate previous sibling of the 
            same name, then assume this node has already been 
            addressed by the first of the contiguous siblings-->
    <xsl:when test="preceding-sibling::*[1][self::bullet]"/>
    <xsl:otherwise><!--at the first of a group of siblings-->
      <ul><!--"walk" along all sibling bullets for list items-->
        <xsl:apply-templates select="." mode="sibling-bullets"/>
      </ul>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

        <!--place each of a group of adjacent siblings-->
<xsl:template match="bullet" mode="sibling-bullets">
  <li><xsl:apply-templates/></li> <!--put out this one-->
                                  <!--go to next one-->
  <xsl:apply-templates mode="sibling-bullets"
            select="following-sibling::*[1][self::bullet]"/>
</xsl:template>

<xsl:template match="listhead">   <!--other stuff-->
  <p><xsl:apply-templates/></p>
</xsl:template>

</xsl:stylesheet>