<?xml version="1.0"?><!--purc2xsl.xsl-->
<!--XSLT 1.0 - http://www.CraneSoftwrights.com/training -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:fo="http://www.w3.org/1999/XSL/Format"
                version="1.0">
<xsl:output method="xml" indent="yes"/>

<!--Important note: Many changes are anticipated from the working
    draft of http://www.w3.org/TR/1999/WD-xsl-19990421 ... this
    works with http://www.jtauber.com/fop/ Version 0.12.1 -->

<xsl:variable name="font-size">20pt</xsl:variable>

<xsl:template match="/purchase">   <!--put all on in one page sequence-->
  <fo:root><fo:layout-master-set>
    <fo:simple-page-master page-master-name="crane"
                           page-width="8.5in" page-height="11in">
     <fo:region-body/></fo:simple-page-master>
    </fo:layout-master-set>
    <fo:page-sequence>
     <fo:sequence-specification>
       <fo:sequence-specifier-single page-master-name="crane"/>
     </fo:sequence-specification>
     <fo:flow><xsl:apply-templates select="customer"/>
       <fo:block space-before.optimum="20pt" font-size="20pt">
         <fo:inline-sequence font-weight="bold">
           <xsl:text>Amount: </xsl:text>
           <xsl:value-of select="product/amount"/>
         </fo:inline-sequence>
       </fo:block>
       <fo:block space-before.optimum="20pt" font-size="20pt">
         <fo:inline-sequence font-weight="bold">
           <xsl:text>Product: </xsl:text>
           <xsl:value-of select="product/@db"/>
         </fo:inline-sequence>
       </fo:block>
     </fo:flow></fo:page-sequence>
  </fo:root></xsl:template>

<xsl:template match="customer">
  <fo:block space-before.optimum="20pt" font-size="20pt">
    <xsl:text>From: </xsl:text>
    <fo:inline-sequence font-style="italic">
      <xsl:text>(Customer Reference) </xsl:text>
      <fo:inline-sequence font-weight="bold">
        <xsl:value-of select="@db"/>
      </fo:inline-sequence></fo:inline-sequence></fo:block>
</xsl:template>

</xsl:stylesheet>